local PAP = {
	Event = {},
	data = {
		playerID = "",
		update = false,
		meter_x = 0,
		meter_y = 0,
		startPAP=0,
		sessionStart =0,
		gainedPAP = nil,
		lastkill = 1
	},
	 
}


local function unitAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		PAP.data.update = true
		end 
		end 
		end
		
local function unitNotAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		PAP.data.update = false
		end 
		end 
		end

function PAP.Event.LoadEnd(handle, identifier)
	if identifier == "Papedia" then
		
		PAP.data.playerID = Inspect.Unit.Lookup("player")
		PAP.data.sessionStart = Inspect.Time.Real()
		PAP.data.startPAP = nil
		
		print("Papedia loaded. /PAP")
	end
end


function PAP.Event.SlashHandler(handle, str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")

		print("Slash Commands:")
		
	end
	

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	PAP.data.meter_x = x - self.originalXDiff
	PAP.data.meter_y = y - self.originalYDiff
  end
end

-- start frames
local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)
local ticker = UI.CreateFrame("Text", "Ticker", box)
local icon = UI.CreateFrame("Texture", "Icon", main)

local ticker2 = UI.CreateFrame("Text", "Ticker2", box)
local icon2 = UI.CreateFrame("Texture", "Icon2", main)


box:SetPoint("TOPLEFT",UIParent,"TOPLEFT",100,100)
box:SetWidth(155)
box:SetHeight(60)
box:SetAlpha(.6)
box:SetVisible(true)
box:SetBackgroundColor(0,0,0)
box:SetLayer(1)

ticker:SetText("No Data")
ticker:SetPoint("TOPRIGHT",box,"TOPRIGHT",0,0)
ticker:SetFontSize(20)
ticker:SetLayer(2)

icon:SetPoint("TOPLEFT",box,"TOPLEFT",0,0)
icon:SetWidth(25)
icon:SetHeight(25)
icon:SetAlpha(1)
icon:SetVisible(true)
icon:SetTexture("Papedia", "time.PNG")
icon:SetLayer(2)



ticker2:SetText("No Data")
ticker2:SetPoint("TOPRIGHT",box,"TOPRIGHT",0,28)
ticker2:SetFontSize(20)
ticker2:SetLayer(2)

icon2:SetPoint("TOPLEFT",box,"TOPLEFT",0,28)
icon2:SetWidth(25)
icon2:SetHeight(25)
icon2:SetAlpha(1)
icon2:SetVisible(true)
icon2:SetTexture("Papedia", "kill.PNG")
icon2:SetLayer(2)


local lastCall = Inspect.Time.Real()

--local getPAP = Inspect.Attunement.Progress()
--result = Inspect.Attunement.Progress()
--accumulated	Experience accumulated so far in this character level.
--needed	Quantity of Experience needed to gain a level.
--rested	Quantity of available rested Experience.


function PAPfade(handle)
if PAP.data.update and Inspect.Attunement.Progress() then
if PAP.data.startPAP == nil then PAP.data.startPAP = Inspect.Attunement.Progress().accumulated return end

if PAP.data.sessionStart == nil then PAP.data.sessionStart = Inspect.Time.Real() return end

local now = Inspect.Time.Real()
	if (now<lastCall+1.2) then 
		return
	end
	
local sessionLen = (now - PAP.data.sessionStart)
local nowPAP = Inspect.Attunement.Progress().accumulated
if nowPAP == nil then return end

local income = (nowPAP - PAP.data.startPAP) / sessionLen

--convert sec to time format
local nSeconds = (Inspect.Attunement.Progress().needed - Inspect.Attunement.Progress().accumulated) / income
local nHours =0
local nMins =0
local nSecs =0

if nSeconds ~= 0 then

nHours = string.format("%02.f", math.floor(nSeconds/3600));
nMins = string.format("%02.f", math.floor(nSeconds/60 - (nHours*60)));
nSecs = string.format("%02.f", math.floor(nSeconds - nHours*3600 - nMins *60));

end

--return nHours..":"..nMins..":"..nSecs




--

ticker:SetText(nHours..":"..nMins..":"..nSecs)

if (nHours == "nan" or nMins == "nan" or nSecs == "nan") then 
ticker:SetText("No Data")
end


lastCall = now

end
end


local function PAPkiller(handle)
if PAP.data.update and Inspect.Attunement.Progress() then

if PAP.data.startPAP == nil then PAP.data.startPAP = Inspect.Attunement.Progress().accumulated end

if PAP.data.gainedPAP == nil then PAP.data.gainedPAP = PAP.data.startPAP end

local deltaPAP = Inspect.Attunement.Progress().accumulated - PAP.data.gainedPAP

--ticker2:SetText(tostring(deltaPAP))

ticker2:SetText(tostring(math.ceil((Inspect.Attunement.Progress().needed-Inspect.Attunement.Progress().accumulated)/deltaPAP)))

PAP.data.gainedPAP = Inspect.Attunement.Progress().accumulated
end
end

local function PAPding(handle, available)

if PAP.data.update and Inspect.Attunement.Progress() then

if PAP.data.sessionStart == nil then return end

local now = Inspect.Time.Real()
	if (now<PAP.data.sessionStart+20) then 
		return
	end


if available == ("0" or '0' or 0)then return end
PAP.data.startPAP = Inspect.Attunement.Progress().accumulated
PAP.data.gainedPAP = Inspect.Attunement.Progress().accumulated
lastCall = Inspect.Time.Real()
PAP.data.sessionStart = Inspect.Time.Real()


ticker:SetText("PA-DING!")
ticker2:SetText("GRATS!")

end
end



local function PAPsave(handle)
 	 
PAPmeter_x = PAP.data.meter_x
PAPmeter_y = PAP.data.meter_y

   end


local function PAPload(handle)

if PAPmeter_x then
PAP.data.meter_x = tonumber(PAPmeter_x)
end

if PAPmeter_y then
 PAP.data.meter_y = tonumber(PAPmeter_y)
 end



box:ClearAll()
box:SetPoint("TOPLEFT", main, "TOPLEFT", PAP.data.meter_x, PAP.data.meter_y)
box:SetWidth(140)
box:SetHeight(60)



   end
	
	AddDragFrame(box)
	



--2.5 prep
Command.Event.Attach(Event.Unit.Availability.Full, unitAvailable, "unitAvailable")
Command.Event.Attach(Event.Unit.Availability.None, unitNotAvailable, "unitNotAvailable")
Command.Event.Attach(Event.Unit.Availability.Partial, unitNotAvailable, "unitNotAvailable")

Command.Event.Attach(Event.System.Update.Begin, PAPfade, "fade")
Command.Event.Attach(Event.Attunement.Progress.Accumulated, PAPkiller, "killer")

Command.Event.Attach(Event.Attunement.Progress.Available, PAPding, "ding")

Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, PAPsave, "Save variables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, PAPload, "Load variables")
Command.Event.Attach(Event.Addon.Load.End, PAP.Event.LoadEnd, "Init")
Command.Event.Attach(Command.Slash.Register("PAP"), PAP.Event.SlashHandler, "Slash")
